/* AddTimeButton.c generated by valac 0.46.6, the Vala compiler
 * generated from AddTimeButton.vala, do not modify */

/*
* Copyright (C) 2018  Eduard Berloso Clarà <eduard.bc.95@gmail.com>
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero General Public License as published
* by the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Affero General Public License for more details.
*
* You should have received a copy of the GNU Affero General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>
#include <stdio.h>

#define APP_WIDGETS_TYPE_ADD_TIME_BUTTON (app_widgets_add_time_button_get_type ())
#define APP_WIDGETS_ADD_TIME_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_WIDGETS_TYPE_ADD_TIME_BUTTON, AppWidgetsAddTimeButton))
#define APP_WIDGETS_ADD_TIME_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_WIDGETS_TYPE_ADD_TIME_BUTTON, AppWidgetsAddTimeButtonClass))
#define APP_WIDGETS_IS_ADD_TIME_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_WIDGETS_TYPE_ADD_TIME_BUTTON))
#define APP_WIDGETS_IS_ADD_TIME_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_WIDGETS_TYPE_ADD_TIME_BUTTON))
#define APP_WIDGETS_ADD_TIME_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_WIDGETS_TYPE_ADD_TIME_BUTTON, AppWidgetsAddTimeButtonClass))

typedef struct _AppWidgetsAddTimeButton AppWidgetsAddTimeButton;
typedef struct _AppWidgetsAddTimeButtonClass AppWidgetsAddTimeButtonClass;
typedef struct _AppWidgetsAddTimeButtonPrivate AppWidgetsAddTimeButtonPrivate;
enum  {
	APP_WIDGETS_ADD_TIME_BUTTON_0_PROPERTY,
	APP_WIDGETS_ADD_TIME_BUTTON_NUM_PROPERTIES
};
static GParamSpec* app_widgets_add_time_button_properties[APP_WIDGETS_ADD_TIME_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AppWidgetsAddTimeButton {
	GtkButton parent_instance;
	AppWidgetsAddTimeButtonPrivate * priv;
	gint time;
	gchar* units;
};

struct _AppWidgetsAddTimeButtonClass {
	GtkButtonClass parent_class;
};

static gpointer app_widgets_add_time_button_parent_class = NULL;

GType app_widgets_add_time_button_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppWidgetsAddTimeButton, g_object_unref)
AppWidgetsAddTimeButton* app_widgets_add_time_button_new (gint time,
                                                          const gchar* units);
AppWidgetsAddTimeButton* app_widgets_add_time_button_construct (GType object_type,
                                                                gint time,
                                                                const gchar* units);
GeeArrayList* app_widgets_add_time_button_load_buttons_from_file (const gchar* path);
void app_widgets_add_time_button_update_buttons_from_file (GeeArrayList* buttons,
                                                           const gchar* path);
void app_widgets_add_time_button_update_button (AppWidgetsAddTimeButton* self,
                                                gint time,
                                                const gchar* units);
gint app_widgets_add_time_button_get_minutes (AppWidgetsAddTimeButton* self);
static void app_widgets_add_time_button_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

AppWidgetsAddTimeButton*
app_widgets_add_time_button_construct (GType object_type,
                                       gint time,
                                       const gchar* units)
{
	AppWidgetsAddTimeButton * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (units != NULL, NULL);
	self = (AppWidgetsAddTimeButton*) g_object_new (object_type, NULL);
	self->time = time;
	_tmp0_ = g_strdup (units);
	_g_free0 (self->units);
	self->units = _tmp0_;
	_tmp1_ = g_strdup_printf ("%d %s", time, units);
	_tmp2_ = _tmp1_;
	gtk_button_set_label ((GtkButton*) self, _tmp2_);
	_g_free0 (_tmp2_);
	return self;
}

AppWidgetsAddTimeButton*
app_widgets_add_time_button_new (gint time,
                                 const gchar* units)
{
	return app_widgets_add_time_button_construct (APP_WIDGETS_TYPE_ADD_TIME_BUTTON, time, units);
}

GeeArrayList*
app_widgets_add_time_button_load_buttons_from_file (const gchar* path)
{
	GeeArrayList* aux = NULL;
	GeeArrayList* _tmp0_;
	gint time = 0;
	gchar* units = NULL;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = gee_array_list_new (APP_WIDGETS_TYPE_ADD_TIME_BUTTON, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	aux = _tmp0_;
	time = 0;
	_tmp1_ = g_strdup ("m");
	units = _tmp1_;
	{
		GFile* file = NULL;
		GFile* _tmp2_;
		GFileInputStream* _tmp3_ = NULL;
		GFile* _tmp4_;
		GFileInputStream* _tmp5_;
		GDataInputStream* reader = NULL;
		GDataInputStream* _tmp6_;
		gchar* info = NULL;
		gchar* _tmp7_;
		_tmp2_ = g_file_new_for_path (path);
		file = _tmp2_;
		_tmp4_ = file;
		_tmp5_ = g_file_read (_tmp4_, NULL, &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			goto __catch0_g_error;
		}
		_tmp6_ = g_data_input_stream_new ((GInputStream*) _tmp3_);
		reader = _tmp6_;
		_tmp7_ = g_strdup ("");
		info = _tmp7_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp8_ = FALSE;
				_tmp8_ = TRUE;
				while (TRUE) {
					gchar* _tmp10_ = NULL;
					GDataInputStream* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					const gchar* _tmp14_;
					gchar** _tmp15_;
					gchar** _tmp16_;
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					const gchar* _tmp19_;
					gchar** _tmp20_;
					gchar** _tmp21_;
					gchar** _tmp22_;
					gint _tmp22__length1;
					const gchar* _tmp23_;
					gchar* _tmp24_;
					GeeArrayList* _tmp25_;
					const gchar* _tmp26_;
					AppWidgetsAddTimeButton* _tmp27_;
					AppWidgetsAddTimeButton* _tmp28_;
					if (!_tmp8_) {
						gint _tmp9_;
						_tmp9_ = i;
						i = _tmp9_ + 1;
					}
					_tmp8_ = FALSE;
					if (!(i < 4)) {
						break;
					}
					_tmp11_ = reader;
					_tmp12_ = g_data_input_stream_read_line (_tmp11_, NULL, NULL, &_inner_error0_);
					_tmp10_ = _tmp12_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_free0 (info);
						_g_object_unref0 (reader);
						_g_object_unref0 (_tmp3_);
						_g_object_unref0 (file);
						goto __catch0_g_error;
					}
					_tmp13_ = _tmp10_;
					_tmp10_ = NULL;
					_g_free0 (info);
					info = _tmp13_;
					_tmp14_ = info;
					_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, ";", 0);
					_tmp17_ = _tmp16_;
					_tmp17__length1 = _vala_array_length (_tmp15_);
					_tmp18_ = _tmp17_[0];
					time = atoi (_tmp18_);
					_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
					_tmp19_ = info;
					_tmp21_ = _tmp20_ = g_strsplit (_tmp19_, ";", 0);
					_tmp22_ = _tmp21_;
					_tmp22__length1 = _vala_array_length (_tmp20_);
					_tmp23_ = _tmp22_[1];
					_tmp24_ = g_strdup (_tmp23_);
					_g_free0 (units);
					units = _tmp24_;
					_tmp22_ = (_vala_array_free (_tmp22_, _tmp22__length1, (GDestroyNotify) g_free), NULL);
					_tmp25_ = aux;
					_tmp26_ = units;
					_tmp27_ = app_widgets_add_time_button_new (time, _tmp26_);
					g_object_ref_sink (_tmp27_);
					_tmp28_ = _tmp27_;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp28_);
					_g_object_unref0 (_tmp28_);
					_g_free0 (_tmp10_);
				}
			}
		}
		_g_free0 (info);
		_g_object_unref0 (reader);
		_g_object_unref0 (_tmp3_);
		_g_object_unref0 (file);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp29_;
		GError* _tmp30_;
		const gchar* _tmp31_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp29_ = stderr;
		_tmp30_ = e;
		_tmp31_ = _tmp30_->message;
		fprintf (_tmp29_, "%s", _tmp31_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (units);
		_g_object_unref0 (aux);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = aux;
	_g_free0 (units);
	return result;
}

void
app_widgets_add_time_button_update_buttons_from_file (GeeArrayList* buttons,
                                                      const gchar* path)
{
	gint time = 0;
	gchar* units = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (buttons != NULL);
	g_return_if_fail (path != NULL);
	time = 0;
	_tmp0_ = g_strdup ("m");
	units = _tmp0_;
	{
		GFile* file = NULL;
		GFile* _tmp1_;
		GFileInputStream* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInputStream* _tmp4_;
		GDataInputStream* reader = NULL;
		GDataInputStream* _tmp5_;
		gchar* info = NULL;
		gchar* _tmp6_;
		_tmp1_ = g_file_new_for_path (path);
		file = _tmp1_;
		_tmp3_ = file;
		_tmp4_ = g_file_read (_tmp3_, NULL, &_inner_error0_);
		_tmp2_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			goto __catch1_g_error;
		}
		_tmp5_ = g_data_input_stream_new ((GInputStream*) _tmp2_);
		reader = _tmp5_;
		_tmp6_ = g_strdup ("");
		info = _tmp6_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp7_ = FALSE;
				_tmp7_ = TRUE;
				while (TRUE) {
					gchar* _tmp9_ = NULL;
					GDataInputStream* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					const gchar* _tmp13_;
					gchar** _tmp14_;
					gchar** _tmp15_;
					gchar** _tmp16_;
					gint _tmp16__length1;
					const gchar* _tmp17_;
					const gchar* _tmp18_;
					gchar** _tmp19_;
					gchar** _tmp20_;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					gpointer _tmp24_;
					AppWidgetsAddTimeButton* _tmp25_;
					const gchar* _tmp26_;
					if (!_tmp7_) {
						gint _tmp8_;
						_tmp8_ = i;
						i = _tmp8_ + 1;
					}
					_tmp7_ = FALSE;
					if (!(i < 4)) {
						break;
					}
					_tmp10_ = reader;
					_tmp11_ = g_data_input_stream_read_line (_tmp10_, NULL, NULL, &_inner_error0_);
					_tmp9_ = _tmp11_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_free0 (info);
						_g_object_unref0 (reader);
						_g_object_unref0 (_tmp2_);
						_g_object_unref0 (file);
						goto __catch1_g_error;
					}
					_tmp12_ = _tmp9_;
					_tmp9_ = NULL;
					_g_free0 (info);
					info = _tmp12_;
					_tmp13_ = info;
					_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, ";", 0);
					_tmp16_ = _tmp15_;
					_tmp16__length1 = _vala_array_length (_tmp14_);
					_tmp17_ = _tmp16_[0];
					time = atoi (_tmp17_);
					_tmp16_ = (_vala_array_free (_tmp16_, _tmp16__length1, (GDestroyNotify) g_free), NULL);
					_tmp18_ = info;
					_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, ";", 0);
					_tmp21_ = _tmp20_;
					_tmp21__length1 = _vala_array_length (_tmp19_);
					_tmp22_ = _tmp21_[1];
					_tmp23_ = g_strdup (_tmp22_);
					_g_free0 (units);
					units = _tmp23_;
					_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
					_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) buttons, i);
					_tmp25_ = (AppWidgetsAddTimeButton*) _tmp24_;
					_tmp26_ = units;
					app_widgets_add_time_button_update_button (_tmp25_, time, _tmp26_);
					_g_object_unref0 (_tmp25_);
					_g_free0 (_tmp9_);
				}
			}
		}
		_g_free0 (info);
		_g_object_unref0 (reader);
		_g_object_unref0 (_tmp2_);
		_g_object_unref0 (file);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		FILE* _tmp27_;
		GError* _tmp28_;
		const gchar* _tmp29_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp27_ = stderr;
		_tmp28_ = e;
		_tmp29_ = _tmp28_->message;
		fprintf (_tmp27_, "%s", _tmp29_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (units);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (units);
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_utf8_get_char (((gchar*) self) + index);
	return result;
}

gint
app_widgets_add_time_button_get_minutes (AppWidgetsAddTimeButton* self)
{
	const gchar* _tmp0_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->units;
	if (string_get_char (_tmp0_, (glong) 0) == ((gunichar) 's')) {
		result = self->time / 60;
		return result;
	} else {
		const gchar* _tmp1_;
		_tmp1_ = self->units;
		if (string_get_char (_tmp1_, (glong) 0) == ((gunichar) 'm')) {
			result = self->time;
			return result;
		} else {
			const gchar* _tmp2_;
			_tmp2_ = self->units;
			if (string_get_char (_tmp2_, (glong) 0) == ((gunichar) 'h')) {
				result = self->time * 60;
				return result;
			} else {
				result = self->time;
				return result;
			}
		}
	}
}

void
app_widgets_add_time_button_update_button (AppWidgetsAddTimeButton* self,
                                           gint time,
                                           const gchar* units)
{
	gchar* _tmp0_;
	gchar* printable_units = NULL;
	gchar* _tmp1_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (units != NULL);
	self->time = time;
	_tmp0_ = g_strdup (units);
	_g_free0 (self->units);
	self->units = _tmp0_;
	_tmp1_ = g_strdup (units);
	printable_units = _tmp1_;
	if (time < 10) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = printable_units;
		_tmp3_ = g_strdup_printf ("%s  ", _tmp2_);
		_g_free0 (printable_units);
		printable_units = _tmp3_;
	}
	_tmp4_ = printable_units;
	_tmp5_ = g_strdup_printf ("%d %s", time, _tmp4_);
	_tmp6_ = _tmp5_;
	gtk_button_set_label ((GtkButton*) self, _tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (printable_units);
}

static void
app_widgets_add_time_button_class_init (AppWidgetsAddTimeButtonClass * klass,
                                        gpointer klass_data)
{
	app_widgets_add_time_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = app_widgets_add_time_button_finalize;
}

static void
app_widgets_add_time_button_instance_init (AppWidgetsAddTimeButton * self,
                                           gpointer klass)
{
}

static void
app_widgets_add_time_button_finalize (GObject * obj)
{
	AppWidgetsAddTimeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_WIDGETS_TYPE_ADD_TIME_BUTTON, AppWidgetsAddTimeButton);
	_g_free0 (self->units);
	G_OBJECT_CLASS (app_widgets_add_time_button_parent_class)->finalize (obj);
}

GType
app_widgets_add_time_button_get_type (void)
{
	static volatile gsize app_widgets_add_time_button_type_id__volatile = 0;
	if (g_once_init_enter (&app_widgets_add_time_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppWidgetsAddTimeButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_widgets_add_time_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppWidgetsAddTimeButton), 0, (GInstanceInitFunc) app_widgets_add_time_button_instance_init, NULL };
		GType app_widgets_add_time_button_type_id;
		app_widgets_add_time_button_type_id = g_type_register_static (gtk_button_get_type (), "AppWidgetsAddTimeButton", &g_define_type_info, 0);
		g_once_init_leave (&app_widgets_add_time_button_type_id__volatile, app_widgets_add_time_button_type_id);
	}
	return app_widgets_add_time_button_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

